program binclient;

{ Simple client for binary data }

uses
   sockets, inetaux, myerror;

const
   RemoteAddress = '127.0.0.1';
   RemotePort : Word = $AFFE;
   OutFileName = 'received.bin';
   const_Amount = 10005;
   BufSize = 2048;
   
   { Yes, I know I could have made that a typed constant, but I like it
     better this way. }

var
   Sock : LongInt;
   sAddr : TInetSockAddr;
   Buffy : array[0..BufSize - 1] of Char; // In honour of the vampire slayer
   fout : File of Char;
   Amount, Len : LongInt;
   Closed : Boolean;
   i : LongInt;

begin
   Sock := Socket(af_inet, sock_stream, 0);
   if Sock = -1 then SockError('Socket: ');
   
   with sAddr do
   begin
      Family := af_inet;
      Port := htons(RemotePort);
      Addr := StrToAddr(RemoteAddress);
   end;

   if not Connect(Sock, sAddr, sizeof(sAddr)) then SockError('Connect: ');
   Writeln('Connected.');
   
   Amount := const_Amount;
   Len := Send(Sock, Amount, sizeof(Amount), 0);
   if Len < sizeof(Amount) then GenError('Couldn''t send a LongInt.');
   
   Assign(fout, OutFileName);
   {$I-}
   Rewrite(fout);
   if IoResult <> 0 then GenError('Couldn''t open file ' + OutFileName);
   {$I+}
   
   Closed := False;
   while not Closed do
   begin
      Len := Recv(Sock, Buffy, sizeof(Buffy), 0);
      if SocketError <> 0 then
      begin
         Close(fout);
         SockError('Recv: ');
      end;
      if Len = 0 then Closed := True
      else for i := 0 to Len - 1 do Write(fout, Buffy[i]);
   end;

   Close(fout);
   Shutdown(Sock, 2);
end.
